package com.inca.npbusi.sales.bms_direct_sa;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.auth.Userruninfo;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.DataCommand;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.mde.CDetailModel;
import com.inca.np.gui.mde.CMasterModel;
import com.inca.np.util.SendHelper;
import com.inca.npx.mde.CMdeModelAp;
import com.inca.npx.ste.Apinfo;
import com.inca.pubsrv.Entrychose;
import com.inca.pubsrv.NpbusiDBHelper;
import java.util.Vector;
import javax.swing.JOptionPane;

public class Bms_direct_sa_mde extends CMdeModelAp {
   private String a = "";
   private String b = "";

   public String getEntryid() {
      return this.a;
   }

   public void setEntryid(String var1) {
      this.a = var1;
   }

   public String getEntryname() {
      return this.b;
   }

   public void setEntryname(String var1) {
      this.b = var1;
   }

   public Bms_direct_sa_mde(CFrame var1, String var2) {
      super(var1, var2);
      this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
      this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
   }

   protected CMasterModel createMastermodel() {
      return new Bms_direct_sa_master(this.frame, this);
   }

   protected CDetailModel createDetailmodel() {
      return new Bms_direct_sa_detail(this.frame, this);
   }

   public String getMasterRelatecolname() {
      return "docid";
   }

   public String getDetailRelatecolname() {
      return "docid";
   }

   public String getSaveCommandString() {
      return "Bms_direct_sa_mde.保存存厂直拨开票";
   }

   public Vector<Apinfo> getParamapinfos() {
      Vector var1;
      (var1 = new Vector()).add(new Apinfo("确定权限", ""));
      var1.add(new Apinfo("回退确定权限", ""));
      var1.add(new Apinfo("生成流程单据权限", ""));
      var1.add(new Apinfo("回退流程单据权限", ""));
      var1.add(new Apinfo("生成销售单的销售模式：空或1-普通销售、2-委托销售", ""));
      var1.add(new Apinfo("是否生成最近进价：0-否，1-是", ""));
      var1.add(new Apinfo("是否生成最近销价：0-否，1-是", ""));
      var1.add(new Apinfo("是否生成货源：0-否，1-是", ""));
      return var1;
   }

   protected int on_actionPerformed(String var1) {
      if (var1.equals("确定")) {
         if (!this.getApvalue("确定权限").equals("1")) {
            this.infoMessage("提示", "对不起，您没有确定的权限！");
            return -1;
         }

         this.a(true);
      } else if (var1.equals("回退确定")) {
         if (!this.getApvalue("回退确定权限").equals("1")) {
            this.infoMessage("提示", "对不起，您没有回退确定权限！");
            return -1;
         }

         Bms_direct_sa_mde var2 = this;
         if (this.getMasterModel().getRow() < 0) {
            this.warnMessage("警告", "请选择正确的单据进行确定!");
         } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
            this.warnMessage("警告", "请选择正确的单据进行回退确定!");
         } else {
            for(int var3 = 0; var3 < var2.getMasterModel().getRowCount(); ++var3) {
               if (var2.getMasterModel().getdbStatus(var3) != 0) {
                  var2.warnMessage("警告", "没有保存不能回退确定,请先保存!");
                  return super.on_actionPerformed(var1);
               }
            }

            int[] var12;
            if ((var12 = var2.getMasterModel().getTable().getSelectedRows()).length < 0) {
               var2.warnMessage("警告", "请选择正确的单据进行回退确定!");
            } else {
               DBTableModel var4 = c();

               int var5;
               String var16;
               for(var5 = 0; var5 < var12.length; ++var5) {
                  int var6 = var12[var5];
                  String var7 = var2.getMasterModel().getItemValue(var6, "docid");
                  var16 = var2.getMasterModel().getItemValue(var6, "usestatus");
                  if (!"1".equals(var16)) {
                     var2.warnMessage("警告", "不是确定状态，不用回退确定！");
                     return super.on_actionPerformed(var1);
                  }

                  var4.appendRow();
                  var4.setItemValue(0, "docid", var7);
               }

               if (var4 != null && var4.getRowCount() > 0) {
                  ClientRequest var15 = new ClientRequest();
                  StringCommand var17 = new StringCommand("Bms_direct_sa_mde.存厂直拨开票回退确定");
                  DataCommand var18;
                  (var18 = new DataCommand()).setDbmodel(var4);
                  var15.addCommand(var17);
                  var15.addCommand(var18);
                  var2.setWaitCursor();
                  var16 = null;

                  try {
                     String var13;
                     if ((var13 = SendHelper.sendRequest(var15).getCommand()).startsWith("+OK")) {
                        for(int var14 = 0; var14 < var12.length; ++var14) {
                           var5 = var12[var14];
                           var2.getMasterModel().setItemValue(var5, "usestatus", "2");
                           var2.getMasterModel().setItemValue(var5, "confirmmanid", "");
                           var2.getMasterModel().setItemValue(var5, "confirmmanname", "");
                           var2.getMasterModel().setItemValue(var5, "confirmdate", "");
                           var2.getMasterModel().setdbStatus(var5, 0);
                           var2.getMasterModel().getDBtableModel().getRecordThunk(var5).setSaveresult(0, "回退确定成功");
                        }
                     } else {
                        var2.errorMessage("错误", "回退确定失败：" + var13);
                     }
                  } catch (Exception var10) {
                     var2.errorMessage("错误", "回退确定不成功原因:" + var10.getMessage());
                     var10.printStackTrace();
                  } finally {
                     var2.setDefaultCursor();
                  }
               } else {
                  var2.warnMessage("警告", "请选择正确的单据进行回退确定!");
               }
            }
         }
      } else if (var1.equals("生成流程单据")) {
         if (!this.getApvalue("生成流程单据权限").equals("1")) {
            this.infoMessage("提示", "对不起，您没有生成流程单据权限！");
            return -1;
         }

         this.a();
      } else if (var1.equals("回退流程单据")) {
         if (!this.getApvalue("回退流程单据权限").equals("1")) {
            this.infoMessage("提示", "对不起，您没有回退流程单据权限！");
            return -1;
         }

         this.b();
      } else if (var1.equals("切换独立单元")) {
         if (this.mastermodel.getModifiedDbmodel().getRowCount() > 0) {
            this.infoMessage("提示", "有尚未保存的数据，请先作保存！");
            return -1;
         }

         if (Entrychose.setUserEntryInfo(this.frame)) {
            this.setEntryid(ClientUserManager.getCurrentUser().getEntryid());
            this.setEntryname(ClientUserManager.getCurrentUser().getEntryname());
            this.getMasterModel().doRetrieve("1=2");
         }

         return 0;
      }

      return super.on_actionPerformed(var1);
   }

   private void a(boolean var1) {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行确定!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行确定!");
      } else {
         for(int var2 = 0; var2 < this.getMasterModel().getRowCount(); ++var2) {
            if (this.getMasterModel().getdbStatus(var2) != 0) {
               this.warnMessage("警告", "没有保存不能确定,请先保存!");
               return;
            }
         }

         int[] var16;
         if ((var16 = this.getMasterModel().getTable().getSelectedRows()).length < 0) {
            this.warnMessage("警告", "请选择正确的单据进行确定!");
         } else {
            DBTableModel var3 = c();

            int var4;
            int var7;
            for(var4 = 0; var4 < var16.length; ++var4) {
               int var5 = var16[var4];
               String var6 = this.getMasterModel().getItemValue(var5, "docid");
               String var18 = this.getMasterModel().getItemValue(var5, "usestatus");
               if (!"2".equals(var18)) {
                  this.mastermodel.getDBtableModel().getRecordThunk(var16[var4]).setSaveresult(-1, "非临时状态单据不可确定");
                  this.mastermodel.tableChanged();
               } else {
                  var7 = var3.getRowCount();
                  var3.appendRow();
                  var3.setItemValue(var7, "docid", var6);
               }
            }

            if (var3 != null && var3.getRowCount() > 0) {
               ClientRequest var17 = new ClientRequest();
               StringCommand var19 = new StringCommand("Bms_direct_sa_mde.存厂直拨开票确定");
               DataCommand var21;
               (var21 = new DataCommand()).setDbmodel(var3);
               var17.addCommand(var19);
               var17.addCommand(var21);
               var17.addCommand(new StringCommand(String.valueOf(var1)));
               this.setWaitCursor();
               Userruninfo var20 = ClientUserManager.getCurrentUser();
               ServerResponse var23 = null;

               try {
                  String var15 = (var23 = SendHelper.sendRequest(var17)).getCommand();
                  var3 = ((DataCommand)var23.commandAt(1)).getDbmodel();
                  if (!var15.startsWith("+OK") && !var15.equals("Again")) {
                     this.errorMessage("错误", "确定失败：" + var15);
                  } else {
                     for(var4 = 0; var4 < var16.length; ++var4) {
                        int var22 = var16[var4];

                        for(var7 = 0; var7 < var3.getRowCount(); ++var7) {
                           String var8 = var3.getItemValue(var7, "docid");
                           String var9 = this.mastermodel.getItemValue(var16[var4], "docid");
                           String var10 = var3.getItemValue(var7, "message");
                           if (var9.equals(var8)) {
                              if ("确定成功".equals(var10)) {
                                 this.getMasterModel().setItemValue(var22, "usestatus", "1");
                                 this.getMasterModel().setItemValue(var22, "confirmmanid", var20.getUserid());
                                 this.getMasterModel().setItemValue(var22, "confirmmanname", var20.getUsername());
                                 this.getMasterModel().setItemValue(var22, "confirmdate", NpbusiDBHelper.getCurrentDate());
                                 this.getMasterModel().getDBtableModel().getRecordThunk(var22).setSaveresult(0, var10);
                              } else {
                                 this.getMasterModel().getDBtableModel().getRecordThunk(var22).setSaveresult(-1, var10);
                              }

                              this.getMasterModel().setdbStatus(var22, 0);
                           }
                        }
                     }
                  }

                  if (var15.equals("Again") && JOptionPane.showConfirmDialog(this.frame, "进价或销价不符合规定，确定继续？") == 0) {
                     this.a(false);
                  }

                  return;
               } catch (Exception var13) {
                  this.errorMessage("错误", "确定不成功原因:" + var13.getMessage());
                  var13.printStackTrace();
               } finally {
                  this.setDefaultCursor();
               }

            } else {
               this.warnMessage("警告", "请选择正确的单据进行确定!");
            }
         }
      }
   }

   private void a() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行生成流程单据!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行生成流程单据!");
      } else {
         for(int var1 = 0; var1 < this.getMasterModel().getRowCount(); ++var1) {
            if (this.getMasterModel().getdbStatus(var1) != 0) {
               this.warnMessage("警告", "没有保存不能生成流程单据,请先保存!");
               return;
            }
         }

         String var14 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "docid");
         String var2 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
         if (!"1".equals(var2)) {
            this.warnMessage("警告", "不是确定状态，不允许生成流程单据！");
         } else {
            int[] var15;
            if ((var15 = this.getDetailModel().getTable().getSelectedRows()).length < 0) {
               this.warnMessage("警告", "请选择正确的细单生成流程单据!");
            } else {
               DBTableModel var3 = d();

               String var6;
               String var7;
               for(int var4 = 0; var4 < var15.length; ++var4) {
                  int var5 = var15[var4];
                  var6 = this.getDetailModel().getItemValue(var5, "dtlid");
                  var7 = this.getDetailModel().getItemValue(var5, "finishflag");
                  if ("1".equals(var7)) {
                     this.warnMessage("警告", "已经生成了流程单据，不允许重复生成！");
                     return;
                  }

                  int var8 = var3.getRowCount();
                  var3.appendRow();
                  var3.setItemValue(var8, "dtlid", var6);
               }

               if (var3 != null && var3.getRowCount() > 0) {
                  String var17;
                  if ((var17 = this.getApvalue("生成销售单的销售模式：空或1-普通销售、2-委托销售")) == null || var17.equals("")) {
                     var17 = "1";
                  }

                  String var18;
                  if ((var18 = this.getApvalue("是否生成最近进价：0-否，1-是")) == null || var18.equals("")) {
                     var18 = "0";
                  }

                  if ((var6 = this.getApvalue("是否生成最近销价：0-否，1-是")) == null || var6.equals("")) {
                     var6 = "0";
                  }

                  if ((var7 = this.getApvalue("是否生成货源：0-否，1-是")) == null || var7.equals("")) {
                     var7 = "0";
                  }

                  ClientRequest var19 = new ClientRequest();
                  StringCommand var16 = new StringCommand("Bms_direct_sa_mde.存厂直拨开票生成流程单据");
                  DataCommand var9;
                  (var9 = new DataCommand()).setDbmodel(var3);
                  var19.addCommand(var16);
                  var19.addCommand(var9);
                  var19.addCommand(new StringCommand(var14));
                  var19.addCommand(new StringCommand(var17));
                  var19.addCommand(new StringCommand(var18));
                  var19.addCommand(new StringCommand(var6));
                  var19.addCommand(new StringCommand(var7));
                  this.setWaitCursor();
                  var2 = null;

                  try {
                     if ((var2 = SendHelper.sendRequest(var19).getCommand()).startsWith("+OK")) {
                        this.infoMessage("提示", "生成流程单据成功。");
                        this.getMasterModel().doRetrieve("docid = " + var14);
                     } else {
                        this.errorMessage("错误", "生成流程单据失败：" + var2);
                     }

                     return;
                  } catch (Exception var12) {
                     this.errorMessage("错误", "生成流程单据不成功原因:" + var12.getMessage());
                     var12.printStackTrace();
                  } finally {
                     this.setDefaultCursor();
                  }

               } else {
                  this.warnMessage("警告", "请选择正确的细单生成流程单据!");
               }
            }
         }
      }
   }

   private void b() {
      if (this.getMasterModel().getRow() < 0) {
         this.warnMessage("警告", "请选择正确的单据进行回退流程单据!");
      } else if (this.getMasterModel().getRow() == this.getMasterModel().getDBtableModel().getRowCount()) {
         this.warnMessage("警告", "请选择正确的单据进行回退流程单据!");
      } else {
         for(int var1 = 0; var1 < this.getMasterModel().getRowCount(); ++var1) {
            if (this.getMasterModel().getdbStatus(var1) != 0) {
               this.warnMessage("警告", "没有保存不能回退流程单据,请先保存!");
               return;
            }
         }

         String var14 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "docid");
         String var2 = this.getMasterModel().getItemValue(this.getMasterModel().getRow(), "usestatus");
         if (!"1".equals(var2)) {
            this.warnMessage("警告", "不是确定状态，不允许回退单据！");
         } else {
            int[] var15;
            if ((var15 = this.getDetailModel().getTable().getSelectedRows()).length < 0) {
               this.warnMessage("警告", "请选择正确的细单回退流程单据!");
            } else {
               DBTableModel var3 = d();

               String var6;
               String var7;
               for(int var4 = 0; var4 < var15.length; ++var4) {
                  int var5 = var15[var4];
                  var6 = this.getDetailModel().getItemValue(var5, "dtlid");
                  var7 = this.getDetailModel().getItemValue(var5, "finishflag");
                  int var8 = var5 + 1;
                  if (!"1".equals(var7)) {
                     this.warnMessage("警告", "还没有生成流程单据，无需回退！行号：" + var8);
                     return;
                  }

                  int var9 = var3.getRowCount();
                  var3.appendRow();
                  var3.setItemValue(var9, "dtlid", var6);
               }

               if (var3 != null && var3.getRowCount() > 0) {
                  String var17;
                  if ((var17 = this.getApvalue("生成销售单的销售模式：空或1-普通销售、2-委托销售")) == null || var17.equals("")) {
                     var17 = "1";
                  }

                  String var18;
                  if ((var18 = this.getApvalue("是否生成最近进价：0-否，1-是")) == null || var18.equals("")) {
                     var18 = "0";
                  }

                  if ((var6 = this.getApvalue("是否生成最近销价：0-否，1-是")) == null || var6.equals("")) {
                     var6 = "0";
                  }

                  if ((var7 = this.getApvalue("是否生成货源：0-否，1-是")) == null || var7.equals("")) {
                     var7 = "0";
                  }

                  ClientRequest var19 = new ClientRequest();
                  StringCommand var20 = new StringCommand("Bms_direct_sa_mde.存厂直拨开票回退流程单据");
                  DataCommand var16;
                  (var16 = new DataCommand()).setDbmodel(var3);
                  var19.addCommand(var20);
                  var19.addCommand(var16);
                  var19.addCommand(new StringCommand(var14));
                  var19.addCommand(new StringCommand(var17));
                  var19.addCommand(new StringCommand(var18));
                  var19.addCommand(new StringCommand(var6));
                  var19.addCommand(new StringCommand(var7));
                  this.setWaitCursor();
                  var14 = null;

                  try {
                     if ((var14 = SendHelper.sendRequest(var19).getCommand()).startsWith("+OK")) {
                        this.infoMessage("提示", "回退流程单据成功。");
                        this.getDetailModel().doRequery();
                     } else {
                        this.errorMessage("错误", "回退流程单据失败：" + var14);
                     }

                     return;
                  } catch (Exception var12) {
                     this.errorMessage("错误", "回退流程单据不成功原因:" + var12.getMessage());
                     var12.printStackTrace();
                  } finally {
                     this.setDefaultCursor();
                  }

               } else {
                  this.warnMessage("警告", "请选择正确的细单回退流程单据!");
               }
            }
         }
      }
   }

   private static DBTableModel c() {
      Vector var0 = new Vector();
      DBColumnDisplayInfo var1 = new DBColumnDisplayInfo("docid", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("message", "varchar");
      var0.add(var1);
      return new DBTableModel(var0);
   }

   private static DBTableModel d() {
      Vector var0 = new Vector();
      DBColumnDisplayInfo var1 = new DBColumnDisplayInfo("dtlid", "number");
      var0.add(var1);
      var1 = new DBColumnDisplayInfo("message", "varchar");
      var0.add(var1);
      return new DBTableModel(var0);
   }
}
